VERSION 5.00
Begin VB.Form Main 
   Caption         =   "Tutorial C - A Little Bit of Everything"
   ClientHeight    =   7200
   ClientLeft      =   60
   ClientTop       =   360
   ClientWidth     =   9600
   Icon            =   "Main.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   480
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   640
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim Engine As New DBTurbo2DEngine
Private Sub Form_Load()
Main.Show
DoEvents

Set Engine = New DBTurbo2DEngine

'set up display
Engine.InitializeDisplay Main.hWnd, False, 640, 480

'Set FPS
Engine.DBFPS.SetFrameRate 60

'set up map view
Engine.SetUpMapView 64, 16, 576, 464, 0

'clear screen
Engine.ClearScreen

'Set up view port
Engine.SetUpViewPort 64, 16, 512, 448

'Set Max Level
Engine.SetMaxLevel 1

'Initialize textures
With Engine.DBTexture
    .SetFolder App.Path + "/"
    .Add 64, "Button.png", , 4
    .Add 32, "Cursor.png", , 4
    .Add 64, "Frame.png", , 4
End With

'variable for loop
Dim I As Integer
'Variables for positions
Dim SX As Single, SY As Single

'Initialize Sprite
With Engine.DBSprite
    For I = 1 To 64
        .Add
        .SetTextureReference I, 1
        .QMSetGetRectangle I, 0, 0, 64, 64
        .QMSetPutRectangle I, 0, 0, 64, 64
        .SetXPosition I, SX * 64
        .SetYPosition I, SY * 64
        SX = SX + 1
        If SX > 7 Then
            SX = 0
            SY = SY + 1
        End If
    Next I
    .Add
    .SetTextureReference 65, 2
    .QMSetPutRectangle 65, -7, -2, 32, 32
    .QMSetGetRectangle 65, 0, 0, 32, 32
    .SetZOrder 65, 1
    .Add
    .SetTextureReference 66, 3
    .QMSetPutRectangle 66, 0, 0, 64, 64
    .QMSetGetRectangle 66, 0, 0, 64, 64
End With

'Initialize counters
With Engine.DBCounter
    For I = 1 To 64
        .Add
        .QMSetUpCounter1Loop I, 0, 150, 5, 1, 1, False
    Next I
End With

'Initialize KeyBoard
With Engine.DBKeyInput
    .Initialize Main.hWnd
    For I = 1 To 211
        .Add I
    Next I
End With

'Initialize Mouse
With Engine.DBMouse
    .InitializeMouse Main.hWnd
    .SetUpMouseViewRect 0, 0, 511, 447
    .AttachSpriteToCursor 65
    .SetMouseSpeed 1
    'this is for the frame
    .SetGridSize 64
End With

'Initialize Sound
With Engine.DBSound
    .Initialize Main.hWnd
    .SetUpDirectionalSound 100, 512, 100
    .SetSoundFolder App.Path + "/"
    .Add "menu"
End With

'set up secondary buffers to play multiple instances of one sound
Engine.DBMath.SoundSetUpSecondaryBuffers 5

'Variable for loop
Dim BRunning As Boolean
BRunning = True

'Variable for sound
Dim OldSprite As Integer
Dim NewSprite As Integer

Do While BRunning = True

'Check KeyBoard
If Engine.DBKeyInput.ReturnKeyDown(DIK_ESCAPE) = True Then BRunning = False

'update sprites
For I = 1 To 64
    'do specular first
    Engine.DBSprite.QMSetSpecular I, 0, Engine.DBCounter.ReturnPositiveInteger(I), Engine.DBCounter.ReturnPositiveInteger(I)
    If Engine.DBMath.MouseHoverSpriteA(I) = True And Engine.DBSprite.GetState(I) = 0 Then
    'sprites first time to hover
        Engine.DBCounter.ResetCounter I
        Engine.DBSprite.SetState I, 10
        Engine.DBMath.SoundSpritePlay 1, 65
    ElseIf Engine.DBMath.MouseHoverSpriteA(I) = True And Engine.DBSprite.GetState(I) = 5 Then
    'sprites not first time so flip
        Engine.DBCounter.QMFlipMinMax1 I, True
        Engine.DBSprite.SetState I, 10
        Engine.DBMath.SoundSpritePlay 1, 65
    ElseIf Engine.DBMath.MouseHoverSpriteA(I) = False And Engine.DBSprite.GetState(I) = 10 Then
    'sprite is no longer being hovered, so flip to decrease specular
        Engine.DBCounter.QMFlipMinMax1 I, True
        Engine.DBSprite.SetState I, 5
    End If
Next I

'Update Frame
With Engine
    .DBSprite.SetXPosition 66, CSng(.DBMouse.GetGridX)
    .DBSprite.SetYPosition 66, CSng(.DBMouse.GetGridY)
End With

'render
Engine.Render

Loop

Set Engine = Nothing
End

End Sub
