VERSION 5.00
Begin VB.Form Main 
   Caption         =   "Tutorial D2 - Poor Man 3D"
   ClientHeight    =   7200
   ClientLeft      =   60
   ClientTop       =   360
   ClientWidth     =   9600
   Icon            =   "Main.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   480
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   640
   StartUpPosition =   2  'CenterScreen
End
Attribute VB_Name = "Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Main Object
Dim Engine As New DBTurbo2DEngine

'The vertex group, it is stand alone
Dim VGroup As New DBVertexGroup

'Variables for Object
Dim XAngle As Single, YAngle As Single, ZAngle As Single
Dim ScaleRate As Single
Dim XTrans As Single, YTrans As Single, ZTrans As Single

'Constants for Cursors
Const XRot As Integer = 1
Const YRot As Integer = 2
Const ZRot As Integer = 3
Const ScRate As Integer = 4
Const XTran As Integer = 5
Const YTran As Integer = 6
Const ZTran As Integer = 7
Const Reset As Integer = 8

Private Sub Form_Load()
Main.Show
DoEvents

Set Engine = New DBTurbo2DEngine

'set up display
Engine.InitializeDisplay Main.hWnd, False, 640, 480

'set up map view
Engine.SetUpMapView 0, 0, 640, 480, 16

'Set FPS
Engine.DBFPS.SetFrameRate 60

'Clear the screen
Engine.ClearScreen

'set maxlevel
Engine.SetMaxLevel 1

'Initialize textures
With Engine.DBTexture
    .SetFolder App.Path + "/"
    .Add 256, "Blank.png", , 4
    .Add 32, "Cursor.png", , 4
    .Add_Odd 128, 64, "Icons.png", , 4
End With

'variable for loop
Dim I As Integer

'Initialize Overlays for Icons
With Engine.DBOverlay
    .QMSetOverlayView 0, 0, 640, 480
    For I = 1 To 8
        .Add
        .QMSetPutRectangle I, 0, 0, 32, 32
        .SetTextureReference I, 3
        .QMAlignLeft I
        .SetZOrder I, 1
    Next I
    .QMSetGetRectangle 1, 0, 0, 32, 32
    .QMSetGetRectangle 2, 32, 0, 32, 32
    .QMSetGetRectangle 3, 64, 0, 32, 32
    .QMSetGetRectangle 4, 96, 0, 32, 32
    .QMSetGetRectangle 5, 0, 32, 32, 32
    .QMSetGetRectangle 6, 32, 32, 32, 32
    .QMSetGetRectangle 7, 64, 32, 32, 32
    .QMSetGetRectangle 8, 96, 32, 32, 32
    .QMCenterVertical 1, 8, 16
End With

'Initialize Sprite
With Engine.DBSprite
    For I = 1 To 6
        .Add
        .SetTextureReference I, 1
        .QMSetGetRectangle I, 0, 0, 16, 16
    Next I
    .Add
    .SetTextureReference 7, 2
    .QMSetGetRectangle 7, 0, 0, 32, 32
    .QMSetPutRectangle 7, -7, -2, 32, 32
    .SetZOrder 7, 1
End With

'Initialize VGroup
With VGroup
    'Create the 12 Vertices
    .VertexAdd -32, -32, 32
    .VertexAdd 32, -32, 32
    .VertexAdd 32, 32, 32
    .VertexAdd -32, 32, 32
    .VertexAdd -32, -32, -32
    .VertexAdd 32, -32, -32
    .VertexAdd 32, 32, -32
    .VertexAdd -32, 32, -32
    'set the origin to be the middle of the screen
    .VertexSetOrigin 320, 240
    'set up fog
    .SpriteSetUpFog 0, -250, True, True, True, False
End With

'Initialize KeyBoard
With Engine.DBKeyInput
    .Initialize Main.hWnd
    For I = 1 To 211
        .Add I
    Next I
End With

'Initialize Mouse
With Engine.DBMouse
    .InitializeMouse Main.hWnd
    .SetUpMouseViewRect 0, 0, 640, 480
    .AttachSpriteToCursor 7
    .SetMouseSpeed 1
    .SetLeftAutoFire True
    .SetRightAutoFire True
    .SetLeftRepeat 1
    .SetRightRepeat 1
End With

'Set up Text
With Engine.DBText
    .CreateFont "timenewroman", 16
    .Add
    .QMSetPutRectangle 1, 0, 0, 100, 20
    .SetText 1, "FPS - 0000"
End With

'Variable for loop
Dim BRunning As Boolean
BRunning = True

'Set up Scale to be 100
ScaleRate = 100

Do While BRunning = True
'Check KeyBoard
If Engine.DBKeyInput.ReturnKeyDown(DIK_ESCAPE) = True Then BRunning = False

'do overlays
For I = 1 To 8
    If Engine.DBMath.MouseHoverOverlayA(I) = True Then
        Engine.DBOverlay.QMSetSpecular I, 50, 50, 50
    Else:
        Engine.DBOverlay.QMSetSpecular I, 0, 0, 0
    End If
Next I

'Check out buttons and change values
With Engine
    If .DBMath.MouseHoverOverlayA(XRot) = True And .DBMouse.GetLeftButton = True Then
        XAngle = XAngle + 2
    ElseIf .DBMath.MouseHoverOverlayA(XRot) = True And .DBMouse.GetRightButton = True Then
        XAngle = XAngle - 2
    End If
    
    If .DBMath.MouseHoverOverlayA(YRot) = True And .DBMouse.GetLeftButton = True Then
        YAngle = YAngle + 2
    ElseIf .DBMath.MouseHoverOverlayA(YRot) = True And .DBMouse.GetRightButton = True Then
        YAngle = YAngle - 2
    End If
    
    If .DBMath.MouseHoverOverlayA(ZRot) = True And .DBMouse.GetLeftButton = True Then
        ZAngle = ZAngle + 2
    ElseIf .DBMath.MouseHoverOverlayA(ZRot) = True And .DBMouse.GetRightButton = True Then
        ZAngle = ZAngle - 2
    End If

    If .DBMath.MouseHoverOverlayA(ScRate) = True And .DBMouse.GetLeftButton = True Then
        ScaleRate = ScaleRate + 2
    ElseIf .DBMath.MouseHoverOverlayA(ScRate) = True And .DBMouse.GetRightButton = True Then
        ScaleRate = ScaleRate - 2
    End If
    
    If .DBMath.MouseHoverOverlayA(XTran) = True And .DBMouse.GetLeftButton = True Then
        XTrans = XTrans + 2
    ElseIf .DBMath.MouseHoverOverlayA(XTran) = True And .DBMouse.GetRightButton = True Then
        XTrans = XTrans - 2
    End If
    
    If .DBMath.MouseHoverOverlayA(YTran) = True And .DBMouse.GetLeftButton = True Then
        YTrans = YTrans + 2
    ElseIf .DBMath.MouseHoverOverlayA(YTran) = True And .DBMouse.GetRightButton = True Then
        YTrans = YTrans - 2
    End If
    
    If .DBMath.MouseHoverOverlayA(ZTran) = True And .DBMouse.GetLeftButton = True Then
        ZTrans = ZTrans + 2
    ElseIf .DBMath.MouseHoverOverlayA(ZTran) = True And .DBMouse.GetRightButton = True Then
        ZTrans = ZTrans - 2
    End If
    
    If .DBMath.MouseHoverOverlayA(Reset) = True And .DBMouse.GetLeftButton = True Then
        XAngle = 0: YAngle = 0: ZAngle = 0
        ScaleRate = 100
        XTrans = 0: YTrans = 0: ZTrans = 0
    End If
    
End With

'update vgroup
    With VGroup
        .VertexReset
        .VertexScale ScaleRate
        .VertexRotateZ ZAngle
        .VertexRotateX XAngle
        .VertexRotateY YAngle
        .VertexTranslate XTrans, YTrans, ZTrans
        .VertexPerspective
        .VertexUpdateOrigin
        'Attach all the sprites as polygons to the vertices
        .CreatePolygon 1, 1, 2, 4, 3
        .CreatePolygon 2, 6, 5, 7, 8
        .CreatePolygon 3, 5, 1, 8, 4
        .CreatePolygon 4, 2, 6, 3, 7
        .CreatePolygon 5, 5, 6, 1, 2
        .CreatePolygon 6, 4, 3, 8, 7
    End With
    
'render
Engine.Render

'Update FPS
Engine.DBText.SetText 1, "FPS - " & Format(Engine.DBFPS.GetFPS)

Loop

Set Engine = Nothing
Set VGroup = Nothing
End

End Sub
